rpm: File Classification API.

rpm 4.12.0.1

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

Files | Typedefs | Enumerations | Functions
File Classification API.
Collaboration diagram for File Classification API.:

## Files
file | rpmfc.h
| Structures and methods for build-time file classification.

## Typedefs
typedef struct rpmfc_s * | rpmfc
typedef rpmFlags | FCOLOR_t
typedef const struct rpmfcTokens_s * | rpmfcToken

## Enumerations
enum | FCOLOR_e { RPMFC_BLACK = 0, RPMFC_ELF32 = (1 << 0), RPMFC_ELF64 = (1 << 1), RPMFC_ELFMIPSN32 = (1 << 2), RPMFC_WHITE = (1 << 29), RPMFC_INCLUDE = (1 << 30), RPMFC_ERROR = (1 << 31) }

## Functions
void | rpmfcPrint (const char *msg, rpmfc fc, FILE *fp)
| Print results of file classification. More...
rpmfc | rpmfcFree (rpmfc fc)
| Destroy a file classifier. More...
rpmfc | rpmfcCreate (const char *rootDir, rpmFlags flags)
| Create a file classifier. More...
RPM_GNUC_DEPRECATED rpmfc | rpmfcNew (void)
rpmRC | rpmfcClassify (rpmfc fc, ARGV_t argv, rpm_mode_t *fmode)
| Build file class dictionary and mappings. More...
rpmRC | rpmfcApply (rpmfc fc)
| Build file/package dependency dictionary and mappings. More...
rpmds | rpmfcProvides (rpmfc fc)
| Retrieve file classification provides. More...
rpmds | rpmfcRequires (rpmfc fc)
| Retrieve file classification requires. More...
rpmds | rpmfcDependencies (rpmfc fc, rpmTagVal tagN)
| Retrieve file classification dependencies. More...

## Detailed Description

## Typedef Documentation

typedef rpmFlags FCOLOR_t

Definition at line 40 of file rpmfc.h.

typedef struct rpmfc_s* rpmfc

Definition at line 21 of file rpmfc.h.

typedef const struct rpmfcTokens_s* rpmfcToken

Definition at line 44 of file rpmfc.h.

## Enumeration Type Documentation

enum FCOLOR_e

Enumerator
RPMFC_BLACK |
RPMFC_ELF32 |
RPMFC_ELF64 |
RPMFC_ELFMIPSN32 |
RPMFC_WHITE |
RPMFC_INCLUDE |
RPMFC_ERROR |

Definition at line 25 of file rpmfc.h.

## Function Documentation

rpmRC rpmfcApply | ( | rpmfc | fc | ) |

Build file/package dependency dictionary and mappings.

Parameters

  fc | file classifier

Returns
  RPMRC_OK on success

rpmRC rpmfcClassify | ( | rpmfc | fc,
|  | ARGV_t | argv,
|  | rpm_mode_t * | fmode
| ) |  |

Build file class dictionary and mappings.

Parameters

  fc | file classifier
  argv | files to classify
  fmode | files mode_t array (or NULL)

Returns
  RPMRC_OK on success

rpmfc rpmfcCreate | ( | const char * | rootDir,
|  | rpmFlags | flags
| ) |  |

Create a file classifier.

Parameters

  rootDir | (build) root directory
  flags | (unused)

Returns
  new file classifier

rpmds rpmfcDependencies | ( | rpmfc | fc,
|  | rpmTagVal | tagN
| ) |  |

Retrieve file classification dependencies.

Parameters

  fc | file classifier
  tagN | name tag of the wanted dependency

Returns
  rpmds dependency set of fc requires

rpmfc rpmfcFree | ( | rpmfc | fc | ) |

Destroy a file classifier.

Parameters

  fc | file classifier

Returns
  NULL always

RPM_GNUC_DEPRECATED rpmfc rpmfcNew | ( | void |  | ) |

Deprecated:
  Create a file classifier.
  Returns
    new file classifier

void rpmfcPrint | ( | const char * | msg,
|  | rpmfc | fc,
|  | FILE * | fp
| ) |  |

Print results of file classification.

Todo:
  Remove debugging routine.
  Parameters

    msg | message prefix (NULL for none)
    fc | file classifier
    fp | output file handle (NULL for stderr)

rpmds rpmfcProvides | ( | rpmfc | fc | ) |

Retrieve file classification provides.

Parameters

  fc | file classifier

Returns
  rpmds dependency set of fc provides

rpmds rpmfcRequires | ( | rpmfc | fc | ) |

Retrieve file classification requires.

Parameters

  fc | file classifier

Returns
  rpmds dependency set of fc requires